// Copyright (C) Geom Software e.U, Bernhard Kornberger, Graz/Austria
//
// This file is part of the WOF software. WOF is commercial software.
// Users holding a license may use this file in accordance with the
// License Agreement.
//
// This software is provided AS IS with NO WARRANTY OF ANY KIND,
// INCLUDING THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS
// FOR A PARTICULAR PURPOSE.
//
// Please contact the author if any conditions of this licensing are
// not clear to you.
//
// Author: Bernhard Kornberger, bkorn (at) geom.at
// http://www.geom.at

#pragma once

namespace GEOM_WOF {


// VERSION NUMBERS
#define PROJECT_VER_MAJOR 1
#define PROJECT_VER_MINOR 3


// DLL IMPORT/EXPORT MACRO
#if defined (_WIN32)
	// ** WINDOWS **
	//#if defined(WOF_EXPORT)
		//#define  CLASS_DECLSPEC __declspec(dllexport)
	//#else
		//#define  CLASS_DECLSPEC __declspec(dllimport)
	//#endif

	// We compile statically!
	#define CLASS_DECLSPEC
#else
	// ** LINUX, MAC and other **
	#define CLASS_DECLSPEC
#endif
/** \brief License-Exception
 *
 * The WofLicenseException is thrown in case of an invalid license
 * state. If your trial has expired and you need the software for
 * your non-commercial personal research please see the guidelines
 * and contact the author.
*/

class WofLicenseException: public std::exception
{
	virtual const char* what() const throw()
	{
		return "WOF License Exception - no valid license";
	}
};

/** \brief Bug-Exception
 *
 * The WofBugException may be thrown in case of unexpected internal states
 * caused by invalid input and/or a bug. In case of a bug please send a
 * bug report with data and it will be fixed asap.
*/
struct WofBugException: public std::exception
{
	virtual const char* what() const throw()
	{
		return "WOF Exception - Bug *OR* wrong usage. Report a bug and it will be fixed quickly: bkorn@geom.at";
	}
};




}
